# Compare soma distribution of each subtypes based on cortical column.

calDistribution = function(data) {
  distribution = array(0, dim = dim(data))
  rowSum = rowSums(data)
  for(iCluster in 1:dim(data)[2]) {
    distribution[,iCluster] = data[,iCluster]/rowSum
  }
  distribution[is.nan(distribution)] = 0
  return(distribution)
}

IT = read.csv2(file = '/home/admin/Documents/YanLab/Task_Local/Classification_IT_Ipsilateral_and_contralateral_isocortex_striatum/level_3_label_CC_clusters.csv', 
               header = FALSE, sep = ",")
PT = read.csv2(file = '/home/admin/Documents/YanLab/Task_Local/Classification_PT_neurons/result/label_CC_clusters.csv', 
               header = FALSE, sep = ",")
CT = read.csv2(file = '/home/admin/Documents/YanLab/Task_Local/Classification_CT_neurons/result/label_CC_clusters_K6.csv', 
               header = FALSE, sep = ",")

# Module = array(0, dim = c(4, 40))
# M_1 = c(5,6,8,11,12,13,14,18,21,26,28,35,40)
# M_2 = c(1,7,9,15,16,19,22,25,30,34)
# M_3 = c(3,10,24,27,39)
# M_4 = c(2,4,17,20,23,29,31,32,33,36,37,38)
# 
# Module[1, M_1] = 1
# Module[2, M_2] = 1
# Module[3, M_3] = 1
# Module[4, M_4] = 1
# 
# rownames(Module) = c('M_1', 'M_2', 'M_3', 'M_4')


dis_IT = calDistribution(IT)
colnames(dis_IT) = paste0("IT-", seq(1, dim(dis_IT)[2]))
rownames(dis_IT) = seq(1,40,1)

dis_PT = calDistribution(PT)
colnames(dis_PT) = paste0("PT-", seq(1, dim(dis_PT)[2]))
rownames(dis_PT) = seq(1,40,1)

dis_CT = calDistribution(CT)
colnames(dis_CT) = paste0("CT-", seq(1, dim(dis_CT)[2]))
rownames(dis_CT) = seq(1,40,1)

dis_whole = cbind(dis_IT, dis_PT, dis_CT)

# 
# annotation_module = array(0, dim = c(40, 1))
# annotation_module[M_1, 1] = 1
# annotation_module[M_2, 1] = 2
# annotation_module[M_3, 1] = 3
# annotation_module[M_4, 1] = 4


col_ha = HeatmapAnnotation(module = annotation_module, 
                           col = list(module = c("1"="#FF0000","2"="#00FF00",
                                                 "3"="#0000FF","4"="#FFFF00")), 
                           which = "column")

# Test Complex Heatmap.
ht = Heatmap(matrix = t(dis_whole[c(1,2,6,7,9,
                                    10,11,12,13,14,15,16,18,19,
                                    20,22,23,24,25,26,28,
                                    30,32,33,34,35,36,37,38,39,40), ]), 
             name = "Ratio",
             
             clustering_distance_rows = "spearman",
             clustering_method_rows = "ward.D2",
             
             cluster_columns = TRUE,
             clustering_distance_columns = "spearman",
             clustering_method_columns = "ward.D2",
             
             show_row_names = TRUE,
             show_column_names = TRUE,
             #bottom_annotation = col_ha,
             
             #cluster_rows = dend1,
             
             #row_dend_side = "left",
             
             #split = 3,
             
             column_split = 3,
             
             width = unit(8, "cm"), 
             height = unit(6, "cm"),
             
             row_names_side = "left",
             row_names_rot = 0,
             row_names_gp = gpar(fontsize = 7),
             
             column_names_side = "top",
             column_names_rot = 90,
             column_names_gp = gpar(fontsize = 7),
             use_raster = TRUE
)
draw(ht)


dend_col = column_dend(ht)
hc = as.hclust(dend_col)

plot(dend_col)

clusters = cutree(hc , k = 8)
rect.hclust(hc, k = 8)


write.table(x = clusters, 
            file = "./cluster_PFC_projection_8.csv", 
            sep = ",", 
            row.names = FALSE, 
            col.names = FALSE)


## Choose number of clusters
dist = Dist(x = dis_whole, method = "spearman")

## Determine the number of clusters
nc = NbClust(data = dis_whole,
             diss = dist,
             distance = NULL,
             min.nc = 1,
             max.nc = 20,
             method = "ward.D2",
             index = "pseudot2"
)

nc$All.index[,"Pseudot2"]
nc$Best.partition


plot(nc$All.index, type = 'l')
