###get different color for different clust
##Arguments
#clust:a vector/factor
getcol <- function(clust,colorpattern=c("rainbow","random")){
  colorpattern<-match.arg(colorpattern)
  
  uniquetiplabel=unique(clust)
  
  switch(colorpattern,
         rainbow={colo=rainbow(length(uniquetiplabel))},
         random={colo=randomcoloR::distinctColorPalette(length(uniquetiplabel))}
  )
  
  tipcol=rainbow(length(clust))
  for(i in 1:length(clust))
  {
    tipcol[i]=colo[which(uniquetiplabel==clust[i])]
  }
  return (tipcol)  
}

###plot color bar
##Arguments:
#nlev:the number of color
#col:color vector
plot_col <- function (nlev, col,...) {
  if(missing(nlev)){nlev<-length(col)}else{stopifnot(is.numeric(nlev))}
  plot(x = c(1, (nlev + 1)), y = c(1, 2),
       xaxs = 'i', yaxs = 'i', xaxt = 'n', yaxt = 'n', type = 'n', ann = F)
  rect(xleft = 1:nlev,
       ybottom = rep(0, (nlev + 1)),
       xright = 2:(nlev + 1),
       ytop = rep(2, (nlev + 1)),
       col = col, border = NA)
  title(...)
}

###calculate the numth parent(when num<0) or the numth child annots(when num>0) of Annot
##required:ANNOTBRANCHID,ANNOT
calannot<-function(Annot,num=NA){
  result=c()
  for(i in 1:length(Annot)){
    annotid=ANNOTBRANCHID[which(ANNOT$Root1==Annot[i])[1]]
    if(!is.numeric(num[i])){
      result=c(result,as.character(ANNOT$Root1[which(substr(ANNOTBRANCHID[1:length(ANNOTBRANCHID)],1,nchar(annotid))==annotid)]))
    }else if(num[i]<0){
      result=c(result,as.character(ANNOT$Root1[which(ANNOTBRANCHID==substr(annotid,1,nchar(annotid)+num[i]))[1]]))
    }else if(num[i]==0){
      result=c(result,Annot[i])
    }else{
      result=c(result,as.character(ANNOT$Root1[which(substr(ANNOTBRANCHID[1:length(ANNOTBRANCHID)],1,nchar(annotid))==annotid&nchar(ANNOTBRANCHID[1:length(ANNOTBRANCHID)])==nchar(annotid)+num[i])]))
    }
  }
  return(result)
}

###
getbranchid <- function(childlist,parentlist,rootid){
  stopifnot(rootid %in% parentlist)
  
  layers<-rep(NA,length(childlist))
  for(i in 1:length(childlist)){
    tmp=childlist[i]
    layers[i]=1
    while(tmp!=rootid){
      tmp=parentlist[which(childlist==tmp)]
      layers[i]=layers[i]+1
    }
  }
  branchid<-rep(NA,length(childlist))
  branchid[which(childlist==rootid)]<-rawToChar(as.raw(65))
  for(i in 1:max(layers)){
    for(j in childlist[which(layers==i)]){
      for(k in 1:length(which(parentlist==j))){
        id=which(parentlist==j)[k]
        branchid[id]=paste0(branchid[which(childlist==parentlist[id])],rawToChar(as.raw(64+k)))
      }
    }
  }
  return(branchid)
}

FDIR<-"~/课题/Work\ report/Code/ForFigures/"

ANNOT<-read.csv(paste0(FDIR,"annot.txt"),sep = ":",header = F)
colnames(ANNOT)<-c("ID","ParentID","Color","Root1","Root2")
ANNOTBRANCHID<-getbranchid(ANNOT$ID[1:nrow(ANNOT)],ANNOT$ParentID[1:nrow(ANNOT)],ANNOT$ID[1])
